/*
 * RequireDocumentIssueValidator.java
 *
 * Created on May 14, 2007, 1:04 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.nwoca.ssdt.jira;

import com.atlassian.jira.ComponentManager;
import com.atlassian.jira.ManagerFactory;
import com.atlassian.jira.issue.Issue;
import com.atlassian.jira.issue.MutableIssue;
import com.atlassian.jira.issue.fields.CustomField;
import com.atlassian.jira.issue.link.IssueLink;
import com.atlassian.jira.issue.link.IssueLinkManager;
import com.atlassian.jira.workflow.WorkflowActionsBean;
import com.opensymphony.module.propertyset.PropertySet;
import com.opensymphony.workflow.InvalidInputException;
import com.opensymphony.workflow.Validator;
import com.opensymphony.workflow.WorkflowException;
import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * Validator blocks Fixed resolution. Use for Workflow steps where "fixed" is
 *not appropriate.
 *
 * @author SMITH
 */
public class RequireEstimateValidator implements Validator {
    
    
    /**
     * Creates a new instance of RequireDocumentIssueValidator.
     */
    public RequireEstimateValidator() {
    }
    
    public void validate(Map transientVars, Map args, PropertySet ps)
    throws InvalidInputException, WorkflowException {
        
        Issue issue = (Issue) transientVars.get("issue");
        
        if (issue.getOriginalEstimate() == null || issue.getOriginalEstimate().equals(0)) {
            throw new InvalidInputException("Original Estimate is required at this step");
        }
        
    }
    
}
